Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeVectorInterpreter.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeVectorInterpreter.cs	(revision 18057)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeVectorInterpreter.cs	(revision 18058)
@@ -369,12 +369,21 @@
       Func<DoubleVector, double> vFunc = null) {
 
-      var offset = node.Offset;
-      var length = node.Length;
+      // Parameters are interpreted as start and end with wrapping
+      var start = node.Offset;
+      var end = node.Length;
 
       DoubleVector SubVector(DoubleVector v) {
-        int index = (int)(offset * v.Count);
-        int count = (int)(length * (v.Count - index));
-        return v.SubVector(index, count);
-      };
+        int startIdx = (int)Math.Round(start * v.Count);
+        int endIdx = (int)Math.Round(end * v.Count);
+        int size = v.Count;
+        if (startIdx < endIdx) {
+          return v.SubVector(startIdx, count: endIdx - startIdx);
+        } else { // wrap around
+          var resultVector = DoubleVector.Build.Dense(size: size - (startIdx - endIdx));
+          v.CopySubVectorTo(resultVector, startIdx, 0, size - startIdx); // copy [startIdx:size] to [0:size-startIdx]
+          v.CopySubVectorTo(resultVector, 0, size - startIdx, endIdx);   // copy [0:endIdx]      to [size-startIdx:size]
+          return resultVector;
+        }
+      }
 
       if (val.IsScalar && sFunc != null) return new EvaluationResult(sFunc(val.Scalar));
@@ -385,12 +394,21 @@
       Func<double, double> sFunc = null,
       Func<DoubleVector, DoubleVector> vFunc = null) {
-      var offset = node.Offset;
-      var length = node.Length;
+      // Parameters are interpreted as start and end with wrapping
+      var start = node.Offset;
+      var end = node.Length;
 
       DoubleVector SubVector(DoubleVector v) {
-        int index = (int)(offset * v.Count);
-        int count = (int)(length * (v.Count - index));
-        return v.SubVector(index, count);
-      };
+        int startIdx = (int)Math.Round(start * v.Count);
+        int endIdx = (int)Math.Round(end * v.Count);
+        int size = v.Count;
+        if (startIdx < endIdx) {
+          return v.SubVector(startIdx, count: endIdx - startIdx);
+        } else { // wrap around
+          var resultVector = DoubleVector.Build.Dense(size: size - (startIdx - endIdx));
+          v.CopySubVectorTo(resultVector, startIdx, 0, size - startIdx); // copy [startIdx:size] to [0:size-startIdx]
+          v.CopySubVectorTo(resultVector, 0, size - startIdx, endIdx);   // copy [0:endIdx]      to [size-startIdx:size]
+          return resultVector;
+        }
+      }
 
       if (val.IsScalar && sFunc != null) return new EvaluationResult(sFunc(val.Scalar));
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/WindowedSymbolTreeNode.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/WindowedSymbolTreeNode.cs	(revision 18057)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/WindowedSymbolTreeNode.cs	(revision 18058)
@@ -37,5 +37,5 @@
     public double Offset {
       get { return offset; }
-      set { offset = Math.Min(Math.Max(value, 0.0), 1.0); }     
+      set { offset = Math.Min(Math.Max(value, 0.0), 1.0); }
     }
     [Storable]
@@ -88,5 +88,5 @@
     public override string ToString() {
       return Symbol.EnableWindowing 
-        ? base.ToString() + $"[{Offset} : {Length}]" 
+        ? base.ToString() + $"[{Offset:f3} : {Length:f3}]" 
         : base.ToString();
     }
Index: branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/GPTP2021VectorBenchmarks/GPTP2021VectorBenchmarksInstanceProvider.cs
===================================================================
--- branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/GPTP2021VectorBenchmarks/GPTP2021VectorBenchmarksInstanceProvider.cs	(revision 18057)
+++ branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/GPTP2021VectorBenchmarks/GPTP2021VectorBenchmarksInstanceProvider.cs	(revision 18058)
@@ -59,10 +59,32 @@
         new GPTP2021VectorBenchmarkDataDescriptor("test_B_01", new []{ "x1", "x2", "v1", "v2" }),
         new GPTP2021VectorBenchmarkDataDescriptor("test_B_02", new []{ "x1", "x2", "v1", "v2" }),
-        new GPTP2021VectorBenchmarkDataDescriptor("test_B_03", new []{ "x1", "x2", "v1", "v2", "v3" }),
-        new GPTP2021VectorBenchmarkDataDescriptor("test_B_04", new []{ "x1", "x2", "v1", "v2", "v3", "v4" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_03", new []{ "x1", "x2", "v1", "v2" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_04", new []{ "x1", "x2", "v1", "v2" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_05", new []{ "x1", "x2", "v1", "v2", "v3" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_06", new []{ "x1", "x2", "v1", "v2", "v3" }),
         new GPTP2021VectorBenchmarkDataDescriptor("test_B_11", new []{ "x1", "x2", "x3", "x4", "v1", "v2", "v3", "v4" }),
         new GPTP2021VectorBenchmarkDataDescriptor("test_B_12", new []{ "x1", "x2", "x3", "x4", "v1", "v2", "v3", "v4" }),
-        new GPTP2021VectorBenchmarkDataDescriptor("test_B_13", new []{ "x1", "x2", "x3", "x4", "x5", "v1", "v2", "v3", "v4", "v5", "v6", "v7" }),
-        new GPTP2021VectorBenchmarkDataDescriptor("test_B_14", new []{ "x1", "x2", "x3", "x4", "x5", "v1", "v2", "v3", "v4", "v5", "v6", "v7", "v8" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_13", new []{ "x1", "x2", "x3", "x4", "v1", "v2", "v3", "v4" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_14", new []{ "x1", "x2", "x3", "x4", "v1", "v2", "v3", "v4" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_15", new []{ "x1", "x2", "x3", "x4", "x5", "v1", "v2", "v3", "v4", "v5", "v6", "v7" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_B_16", new []{ "x1", "x2", "x3", "x4", "x5", "v1", "v2", "v3", "v4", "v5", "v6", "v7" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_C_01", new []{ "x1", "x2", "v1", "v2", "v3", "v4", "v5", "v6"}, "y1"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_C_01", new []{ "x1", "x2", "v1", "v2", "v3", "v4", "v5", "v6"}, "y2"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_C_01", new []{ "x1", "x2", "v1", "v2", "v3", "v4", "v5", "v6"}, "y3"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_C_01", new []{ "x1", "x2", "v1", "v2", "v3", "v4", "v5", "v6"}, "y4"),
+        //new GPTP2021VectorBenchmarkDataDescriptor("test_B_14", new []{ "x1", "x2", "x3", "x4", "x5", "v1", "v2", "v3", "v4", "v5", "v6", "v7", "v8" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_I_01_Nguyen_7",         new []{ "x" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_I_02_Keijzer_6",        new []{ "x", "y" , "z" }, "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_I_03_Vladislavleva_14", new []{ "x1", "x2", "x3", "x4", "x5" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_I_04_Pagie_1",          new []{ "x", "y" }, "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_I_05_Poly_10",          new []{ "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_I_06_Friedman_2",       new []{ "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_01_Nguyen_7_M1",         new []{ "x" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_02_Keijzer_6_M1",        new []{ "x", "y" , "z" }, "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_03_Vladislavleva_14_M1", new []{ "x1", "x2", "x3", "x4", "x5" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_03_Vladislavleva_14_M2", new []{ "x1", "x2", "x3", "x4", "x5" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_04_Pagie_1_M1",          new []{ "x", "y" }, "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_05_Poly_10_M1",          new []{ "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10" }),
+        new GPTP2021VectorBenchmarkDataDescriptor("test_M_06_Friedman_2_M1",       new []{ "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10" }),
 
         new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_A_01", Flatten(U("v1"))),
@@ -78,10 +100,33 @@
         new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_01", Flatten(S("x1"), S("x2"), U("v1"), U("v2"))),
         new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_02", Flatten(S("x1"), S("x2"), U("v1"), U("v2"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_03", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_04", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"), U("v4"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_03", Flatten(S("x1"), S("x2"), U("v1"), U("v2"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_04", Flatten(S("x1"), S("x2"), U("v1"), U("v2"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_05", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_06", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"))),
+        //new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_04", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"), U("v4"))),
         new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_11", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), U("v1"), U("v2"), U("v3"), U("v4"))),
         new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_12", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), U("v1"), U("v2"), U("v3"), U("v4"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_13", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6"), U("v7"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6"), U("v7"), U("v8"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_13", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), U("v1"), U("v2"), U("v3"), U("v4"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), U("v1"), U("v2"), U("v3"), U("v4"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_15", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6"), U("v7"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_16", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6"), U("v7"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_C_01", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6")), "y1"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_C_01", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6")), "y2"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_C_01", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6")), "y3"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_C_01", Flatten(S("x1"), S("x2"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6")), "y4"),
+        //new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_B_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), U("v1"), U("v2"), U("v3"), U("v4"), U("v5"), U("v6"), U("v7"), U("v8"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_I_01_Nguyen_7",         Flatten(S("x"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_I_02_Keijzer_6",        Flatten(S("x"), S("y"), S("z")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_I_03_Vladislavleva_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_I_04_Pagie_1",          Flatten(S("x"), S("y")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_I_05_Poly_10",          Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), S("x6"), S("x7"), S("x8"), S("x9"), S("x10"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_I_06_Friedman_2",       Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), S("x6"), S("x7"), S("x8"), S("x9"), S("x10"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_01_Nguyen_7_M1",         Flatten(U("x"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_02_Keijzer_6_M1",        Flatten(U("x"), U("y"), U("z")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_03_Vladislavleva_14_M1", Flatten(U("x1"), U("x2"), U("x3"), U("x4"), U("x5"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_03_Vladislavleva_14_M2", Flatten(U("x1"), U("x2"), U("x3"), U("x4"), U("x5"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_04_Pagie_1_M1",          Flatten(U("x"), U("y")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_05_Poly_10_M1",          Flatten(U("x1"), U("x2"), U("x3"), U("x4"), U("x5"), U("x6"), U("x7"), U("x8"), U("x9"), U("x10"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("unrolled_test_M_06_Friedman_2_M1",       Flatten(U("x1"), U("x2"), U("x3"), U("x4"), U("x5"), U("x6"), U("x7"), U("x8"), U("x9"), U("x10"))),
 
         new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_A_01", Flatten(A("v1"))),
@@ -97,10 +142,33 @@
         new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_01", Flatten(S("x1"), S("x2"), A("v1"), A("v2"))),
         new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_02", Flatten(S("x1"), S("x2"), A("v1"), A("v2"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_03", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_04", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"), A("v4"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_03", Flatten(S("x1"), S("x2"), A("v1"), A("v2"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_04", Flatten(S("x1"), S("x2"), A("v1"), A("v2"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_05", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_06", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"))),
+        //new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_04", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"), A("v4"))),
         new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_11", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), A("v1"), A("v2"), A("v3"), A("v4"))),
         new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_12", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), A("v1"), A("v2"), A("v3"), A("v4"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_13", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6"), A("v7"))),
-        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6"), A("v7"), A("v8"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_13", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), A("v1"), A("v2"), A("v3"), A("v4"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), A("v1"), A("v2"), A("v3"), A("v4"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_15", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6"), A("v7"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_16", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6"), A("v7"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_C_01", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6")), "y1"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_C_01", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6")), "y2"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_C_01", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6")), "y3"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_C_01", Flatten(S("x1"), S("x2"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6")), "y4"),
+        //new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_B_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), A("v1"), A("v2"), A("v3"), A("v4"), A("v5"), A("v6"), A("v7"), A("v8"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_I_01_Nguyen_7",         Flatten(S("x"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_I_02_Keijzer_6",        Flatten(S("x"), S("y"), S("z")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_I_03_Vladislavleva_14", Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_I_04_Pagie_1",          Flatten(S("x"), S("y")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_I_05_Poly_10",          Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), S("x6"), S("x7"), S("x8"), S("x9"), S("x10"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_I_06_Friedman_2",       Flatten(S("x1"), S("x2"), S("x3"), S("x4"), S("x5"), S("x6"), S("x7"), S("x8"), S("x9"), S("x10"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_01_Nguyen_7_M1",         Flatten(A("x"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_02_Keijzer_6_M1",        Flatten(A("x"), A("y"), A("z")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_03_Vladislavleva_14_M1", Flatten(A("x1"), A("x2"), A("x3"), A("x4"), A("x5"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_03_Vladislavleva_14_M2", Flatten(A("x1"), A("x2"), A("x3"), A("x4"), A("x5"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_04_Pagie_1_M1",          Flatten(A("x"), A("y")), "f"),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_05_Poly_10_M1",          Flatten(A("x1"), A("x2"), A("x3"), A("x4"), A("x5"), A("x6"), A("x7"), A("x8"), A("x9"), A("x10"))),
+        new GPTP2021VectorBenchmarkDataDescriptor("pre_aggregated_test_M_06_Friedman_2_M1",       Flatten(A("x1"), A("x2"), A("x3"), A("x4"), A("x5"), A("x6"), A("x7"), A("x8"), A("x9"), A("x10"))),
       };
     }